
package happert;

public class GameDifficultySettings {
    private GameDifficulty gameDifficulty;
    private int stonePerc;
    private int granitePerc;
    private int happerSpeed;
    private GameIntelligence gameIntelligence;

    public GameDifficulty getDifficulty() {
        return gameDifficulty;
    }
    
    public int getStonePercentage() {
        return stonePerc;
    }

    public int getGranitePercentage() {
        return granitePerc;
    }

    public int getHapperSpeed() {
        return happerSpeed;
    }

    public GameIntelligence getGameIntelligence() {
        return gameIntelligence;
    }


    public void setDifficulty( GameDifficulty gd ) {
        gameDifficulty = gd;
        
        if( gameDifficulty == GameDifficulty.Easy ) {
            setStonePercentage(30);
            setGranitePercentage(2);
            setHapperSpeed(800);
        } else if ( gameDifficulty == GameDifficulty.Normal ) {
            setStonePercentage(20);
            setGranitePercentage(7);
            setHapperSpeed(450);
        } else if ( gameDifficulty == GameDifficulty.Hard ) {
            setStonePercentage(15);
            setGranitePercentage(10);
            setHapperSpeed(200);
        } else {
            // The function doesn't support other options
        }

        // make sure we always have a strategy by default
        if( getGameIntelligence() == null ) {
            setGameIntelligence( gameIntelligence.Normal );
        }
    }

    public void setStonePercentage( int perc ) {
        stonePerc = perc;
    }

    public void setGranitePercentage( int perc ) {
        granitePerc = perc;
    }

    public void setHapperSpeed( int speed ) {
        happerSpeed = speed;
    }

    public void setGameIntelligence( GameIntelligence gi ) {
        gameIntelligence = gi;
    }

}
