
package happert.UI;

import happert.Game;

public class HappertWindow extends javax.swing.JFrame {
    private final Game game;

    /** Creates new form HappertWindow */
    /** 
     * handhaaf deze ctor voor de Netbeans form designer
     * (runtime zou hij niet gebruikt moeten worden
     *
     */
    public HappertWindow() {
        this(new Game());

    }

    public HappertWindow(Game game) {
        this.game = game;
        assert game != null : "game is null";
        

        initComponents();

        ((HapperPanel)happerPanel).setGame(game);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        happerPanel = new HapperPanel();
        buttonPanel = new javax.swing.JPanel();
        startButton = new javax.swing.JButton();
        herstelButton = new javax.swing.JButton();
        stopButton = new javax.swing.JButton();
        jMenuBar1 = new javax.swing.JMenuBar();
        menuBar = new javax.swing.JMenu();
        miStart = new javax.swing.JMenuItem();
        miReset = new javax.swing.JMenuItem();
        miStop = new javax.swing.JMenuItem();
        menuConfiguration = new javax.swing.JMenu();
        miOpenConfiguration = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent evt) {
                formComponentResized(evt);
            }
        });

        javax.swing.GroupLayout happerPanelLayout = new javax.swing.GroupLayout(happerPanel);
        happerPanel.setLayout(happerPanelLayout);
        happerPanelLayout.setHorizontalGroup(
            happerPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 707, Short.MAX_VALUE)
        );
        happerPanelLayout.setVerticalGroup(
            happerPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 539, Short.MAX_VALUE)
        );

        getContentPane().add(happerPanel, java.awt.BorderLayout.CENTER);

        buttonPanel.setLayout(new java.awt.GridLayout(20, 1));

        startButton.setText("Start");
        startButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                startButtonActionPerformed(evt);
            }
        });
        buttonPanel.add(startButton);

        herstelButton.setText("Reset");
        herstelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                herstelButtonActionPerformed(evt);
            }
        });
        buttonPanel.add(herstelButton);

        stopButton.setText("Stop");
        stopButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                stopButtonActionPerformed(evt);
            }
        });
        buttonPanel.add(stopButton);

        getContentPane().add(buttonPanel, java.awt.BorderLayout.EAST);

        menuBar.setText("Spel");

        miStart.setText("Start");
        miStart.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                miStartMousePressed(evt);
            }
        });
        menuBar.add(miStart);

        miReset.setText("Reset");
        miReset.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                miResetMousePressed(evt);
            }
        });
        menuBar.add(miReset);

        miStop.setText("Stop");
        miStop.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                miStopMousePressed(evt);
            }
        });
        menuBar.add(miStop);

        jMenuBar1.add(menuBar);

        menuConfiguration.setText("Configuratie");

        miOpenConfiguration.setText("Configuratiescherm");
        miOpenConfiguration.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                miOpenConfigurationMousePressed(evt);
            }
        });
        menuConfiguration.add(miOpenConfiguration);

        jMenuBar1.add(menuConfiguration);

        setJMenuBar(jMenuBar1);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void startButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_startButtonActionPerformed
       happerPanel.requestFocusInWindow();
       game.Start();
       System.out.println("Game started");

    }//GEN-LAST:event_startButtonActionPerformed

    private void herstelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_herstelButtonActionPerformed
        game.Stop();
        game.Reset();
        System.out.println("Game reset");
    }//GEN-LAST:event_herstelButtonActionPerformed

    private void stopButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_stopButtonActionPerformed
        game.Stop();
        System.out.println("Game stopping");
    }//GEN-LAST:event_stopButtonActionPerformed

    private void formComponentResized(java.awt.event.ComponentEvent evt) {//GEN-FIRST:event_formComponentResized
        game.RendererResize();
    }//GEN-LAST:event_formComponentResized

    private void miStartMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_miStartMousePressed
        happerPanel.requestFocusInWindow();
        game.Start();
    }//GEN-LAST:event_miStartMousePressed

    private void miOpenConfigurationMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_miOpenConfigurationMousePressed
        if ( ! game.isRunning() ) {
            new ConfigurationWindow( game ).setVisible(true);
        }
    }//GEN-LAST:event_miOpenConfigurationMousePressed

    private void miResetMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_miResetMousePressed
        game.Stop();
        game.Reset();
    }//GEN-LAST:event_miResetMousePressed

    private void miStopMousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_miStopMousePressed
        game.Stop();
    }//GEN-LAST:event_miStopMousePressed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new HappertWindow().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JPanel happerPanel;
    private javax.swing.JButton herstelButton;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenu menuBar;
    private javax.swing.JMenu menuConfiguration;
    private javax.swing.JMenuItem miOpenConfiguration;
    private javax.swing.JMenuItem miReset;
    private javax.swing.JMenuItem miStart;
    private javax.swing.JMenuItem miStop;
    private javax.swing.JButton startButton;
    private javax.swing.JButton stopButton;
    // End of variables declaration//GEN-END:variables

    /**
     * @return the happerPanel's IRender interface
     */
    public IRender getRenderer() {
        return (IRender)happerPanel;
    }
}
