package happert.gameobjects;

import happert.playfield.Point;
import happert.playfield.Playfield;

public class GameObjectBuilder {

    public enum GameObjectEnum {
        ROCK,
        GRANITE,
        PLAYER,
        HAPPERT
    }

    private Playfield playfield;

    public GameObjectBuilder(Playfield playfield) {
        this.playfield = playfield;
    }

    /**
     * Builder for the GameObjects
     *
     * @param gameObject The Game object type
     * @param location The location the object should be placed
     * @return
     */
    public GameObject createGameObject(GameObjectEnum gameObject, Point location){
        switch (gameObject) {
            case ROCK :
                return new Rock(location, playfield);
            case GRANITE :
                return new Granite(location);
            case PLAYER:
                return new Player(location, playfield);
            case HAPPERT:
                return new Happert(location, playfield);
            default:
                throw new IllegalArgumentException("Unkown gameobject " + gameObject);
        }
    }
}
