
package happert.gameobjects.happertstrategies;

import happert.gameobjects.DirectionEnum;
import happert.gameobjects.MovableGameObject;
import happert.playfield.Playfield;

public class DijkstraMoveStrategy extends MoveStrategy {
    private Playfield playfield;

    public DijkstraMoveStrategy(MovableGameObject host, MovableGameObject goal, Playfield playfield) {
        super(host, goal);
        this.playfield = playfield;
    }
    
    @Override
    public DirectionEnum findMoveDirection() {
        // setup and call dijkstra
        Dijkstra dijkstra = new Dijkstra(new PlayfieldAdapter(playfield), getHost().getLocation(), getGoal().getLocation());
        boolean pathFound = dijkstra.find();

        if (pathFound) {
            return dijkstra.popStep();
        } else {
            return DirectionEnum.None;
        }
    }


}
