package happert.gameobjects.happertstrategies;

import happert.gameobjects.GameObject;
import happert.playfield.Playfield;
import happert.playfield.Point;

class PlayfieldAdapter implements ISearchField {
    private final Playfield playfield;
    
    public PlayfieldAdapter(Playfield playfield)  {
        assert playfield != null : "playfield is null";
        this.playfield = playfield;
    }

    public int getWidth() {
        return playfield.getWidth();
    }

    public int getHeight() {
        return playfield.getHeight();
    }

    public boolean passable(Point loc) {
        GameObject cell = playfield.getCellContents(loc);
        return cell == null;
    }

}
