
package happert.gameobjects.happertstrategies;

import happert.gameobjects.DirectionEnum;
import happert.playfield.Point;

class Scout implements Comparable<Scout> {

    private final Point point;
    private final int wait;
    private final DirectionEnum direction;

    public Scout(int wait, Point point, DirectionEnum direction) {
        this.point = point;
        this.wait = wait;
        this.direction = direction;
    }

    public int compareTo(Scout o) {
        if (this.wait == o.getWait()) {
            return 0;
        } else if (this.wait < o.getWait()) {
            return -1;
        } else {
            return 1;
        }
    }

    /**
     * @return the point
     */
    public Point getPoint() {
        return point;
    }

    /**
     * @return the wait
     */
    public int getWait() {
        return wait;
    }

    /**
     * @return the direction
     */
    public DirectionEnum getDirection() {
        return direction;
    }

}
