package happert.gameobjects;

import happert.playfield.*;
import happert.testutil.TestUtility;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

public class HappertTest {
    private final String[] OPEN_FIELD = {   ".....",
                                            "..P..",
                                            ".....",
                                            "..H..",
                                            "....."
                                           };

    private final String[] BOXEDIN_FIELD = {".....",
                                            "..P..",
                                            ".###.",
                                            ".#H#.",
                                            ".###."
                                           };

    public HappertTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
        
    }

    @After
    public void tearDown() {
    }

    /**
     * Test of move method, of class Happert.
     */
    @Test
    public void OpenPlayfieldShouldBeAbleToMove() {
        // arrange
        
        Happert happert = constructGetHappertFromStringTemplate(OPEN_FIELD);
        // act
        boolean moveOK = happert.move();
        // assert
        assertTrue("Happer should be able to move", moveOK);
    }

    @Test
    public void OpenPlayfieldMove() {
        // arrange
        Happert happert = constructGetHappertFromStringTemplate(OPEN_FIELD);
        Point happertLoc = happert.getLocation();
        // act
        happert.move();
        // assert
        assertNotSame("Happer should have moved", happertLoc, happert.getLocation());
    }

    @Test
    public void BoxedInHapperShouldNotBeAbleToMove() {
        // arrange
        Happert happert = constructGetHappertFromStringTemplate(BOXEDIN_FIELD);
        // act
        boolean moveOK = happert.move();
        // assert
        assertFalse("Happer should not be able to move", moveOK);
    }

    @Test
    public void BoxedInHapperShouldNotMove() {
        // arrange
        Happert happert = constructGetHappertFromStringTemplate(BOXEDIN_FIELD);
        Point happertLoc = happert.getLocation();
        // act
        happert.move();
        // assert
        assertSame("Happert shouldn't be able to move.", happertLoc, happert.getLocation());
    }
    
    public static Happert constructGetHappertFromStringTemplate(String[] pft) {
        PlayfieldBuilder pfBuilder = TestUtility.constructPlayfieldFromStringTemplate(pft);
        Happert happert = pfBuilder.getHappert();
        happert.huntFor(pfBuilder.getPlayer());
        return happert;
    }
}