package happert.gameobjects.happertstrategies;

import happert.gameobjects.DirectionEnum;
import happert.playfield.Point;
import org.junit.Test;
import static org.junit.Assert.*;

public class ScoutTest {
    private final Point aPoint = new Point(0,0);
    private final DirectionEnum aDirection = DirectionEnum.None;

    @Test
    public void testCompareTo_ShorterWait_ShouldCompareAsShorter() {
        Scout shorter = new Scout(5, aPoint, aDirection);
        Scout longer = new Scout(10, aPoint, aDirection);

        assertTrue(shorter.compareTo(longer) < 0);
    }

    @Test
    public void testCompareTo_LongerWait_ShouldCompareAsLonger() {
        Scout shorter = new Scout(5, aPoint, aDirection);
        Scout longer = new Scout(10, aPoint, aDirection);

        assertTrue(longer.compareTo(shorter) > 0);
    }

    @Test
    public void testCompareTo_EqualWait_ShouldCompareAsEqual() {
        Scout someScout = new Scout(5, aPoint, aDirection);

        assertTrue(someScout.compareTo(someScout) == 0);
    }

}
